#ifndef NPCS_HPP_INCLUDED
#define NPCS_HPP_INCLUDED

#include "../../Core/Classes/NPC.hpp"
#include "../../Core/Types/Tile.hpp"
#include "../../Core/Types/Convex.hpp"
#include <functional>
#include <cstdint>
#include <vector>
#include <string>


/** @addtogroup Models
* @{ */
class NPCs
{
    public:
        static std::vector<NPC> GetAll();
        static std::vector<NPC> GetAll(const Tile& Tile);
        static std::vector<NPC> GetAll(std::int32_t ID);
        static std::vector<NPC> GetAll(const std::string& Name);
        static std::vector<NPC> GetAll(const std::vector<std::int32_t>& IDs);
        static std::vector<NPC> GetAll(const std::vector<std::string>& Names);
        static std::vector<NPC> GetAll(const std::function<bool (NPC&)>& Filter);

        static NPC Get();
        static NPC Get(const Tile& Tile);
        static NPC Get(std::int32_t ID);
        static NPC Get(const std::string& Name);
        static NPC Get(const std::vector<std::int32_t>& IDs);
        static NPC Get(const std::vector<std::string>& Names);
        static NPC Get(const std::function<bool (NPC&)>& Filter);

        static Tile GetTileOf(NPC NPC);

        static Convex GetConvexOf(NPC NPC);
};
/** @} */

#endif // NPCS_HPP_INCLUDED
